grammar core;

nonterminal StringList with {sh, st, empty};

synthesized attribute empty :: Boolean;
synthesized attribute sh    :: String;
synthesized attribute st    :: StringList;

function emptyString
StringList ::= 
{
  return empty_string();
}

abstract production empty_string
top::StringList ::= 
{
  top.empty = true;
  top.sh = error("Head not defined on an empty core string list");
  top.st = error("Tail not defined on an empty core string list");
}


function consString
StringList ::= h::String t::StringList
{
  return cons_string(h, t'');
}

abstract production cons_string
top::StringList ::= h::String t::StringList
{
  top.empty = false;
  top.sh = h;
  top.st = t'';
}

function appendString
StringList ::= e1::StringList e2::StringList
{
 return if e1.empty
        then e2''
        else consString ( e1.sh , appendString ( e1.st, e2'' ) ) ;
}

--function containsString
--Boolean ::= s::String sl::StringList
--{
--  return if sl.empty
-- 	 then false
--	 else if (sl.sh == s)
--	      then true
--              else containsString(s, sl.st);
--}
--
