grammar silver:analysis:agnosis:core;
import silver:base:core;

attribute pInNames occurs on ProductionSignature, ProductionRHS, ProductionRHSElem;
attribute outName occurs on ProductionSignature, ProductionLHS, ProductionLHSElem;


synthesized attribute fullSigNames :: [String];
attribute fullSigNames occurs on AspectSignature, AspectLHS, AspectLHSElem, AspectRHS, AspectRHSElem;
attribute fullSigNames occurs on ProductionSignature, ProductionLHS, ProductionLHSElem, ProductionRHS, ProductionRHSElem;

autocopy attribute fullSignatureNames :: [String];
attribute fullSignatureNames occurs on ProductionBody, ProductionStmts, ProductionStmt, AttributeDef, LHSExpr, Expr, Exprs;

autocopy attribute thisName :: String;
attribute thisName occurs on ProductionBody, ProductionStmts, ProductionStmt, AttributeDef, LHSExpr, Expr, ExprInh, ExprLHSExpr, ForwardInh, ForwardLHSExpr, Exprs;


aspect production productionDcl
 top::AGDcl ::=
   a::Abstract_kwd p::Production_kwd id::Id_t ns::ProductionSignature
   body::ProductionBody
{
  top.agnosis = cons(pDclData(makeName(fName), ns.pInNames, ns.outName), body.agnosis);
  body.thisName = makeName(fName);
  body.fullSignatureNames = ns.fullSigNames;
}

aspect production productionSignatureEmptyRHS
top::ProductionSignature ::= lhs::ProductionLHS kwd::CCEQ_t
{
  top.pInNames = [];
  top.outName = lhs.outName;
  top.fullSigNames = lhs.fullSigNames;
}

aspect production productionSignature
top::ProductionSignature ::= lhs::ProductionLHS kwd::CCEQ_t rhs::ProductionRHS 
{
  top.pInNames = rhs.pInNames;
  top.outName = lhs.outName;

  top.fullSigNames = lhs.fullSigNames +++ rhs.fullSigNames;

}

aspect production productionLHS
top::ProductionLHS ::= lhs::ProductionLHSElem
{
  top.outName = lhs.outName;
  top.fullSigNames = lhs.fullSigNames;
}

aspect production productionLHSElem
top::ProductionLHSElem ::= id::Id_t kwd::HasType_t t::Type
{
  top.outName = makeName(t.typerep.typeName);
  top.fullSigNames = [fName];
}

aspect production productionRHSEmpty
top::ProductionRHS ::=
{
  top.pInNames = [];
  top.fullSigNames = [];
}

aspect production productionRHSSingle
top::ProductionRHS ::= rhs::ProductionRHSElem
{
  top.pInNames = rhs.pInNames;
  top.fullSigNames = rhs.fullSigNames;
}

aspect production productionRHSCons
top::ProductionRHS ::= h::ProductionRHSElem t::ProductionRHS
{
  top.pInNames = h.pInNames +++ t.pInNames;
  top.fullSigNames = h.fullSigNames +++ t.fullSigNames;
}

aspect production productionRHSElem
top::ProductionRHSElem ::= id::Id_t kwd::HasType_t t::Type
{
  top.pInNames = if t.typerep.isNonTerminal 
		then [ntDclData(makeName(t.typerep.typeName))]
		else [tDclData(makeName(t.typerep.typeName))];

  top.fullSigNames = [fName];
}

