grammar silver:analysis:agnosis:type:io;
import silver:analysis:agnosis:core;
import silver:base;


aspect production isFileFunction
top::Expr ::= i::IsFile_kwd l::LParen_t e1::Expr c::Comma_t e2::Expr r::RParen_t
{
  top.isConstant = true;
  top.isChild = false;
  top.dataName = "";
  
  top.baseType = top.typerep;
  top.lastAccess = [];
  top.possibleAgnosis = [];
  top.agnosis = e1.agnosis +++ e1.lastAccess +++ e2.agnosis +++ e2.lastAccess;
}

aspect production isDirectoryFunction
top::Expr ::= i::IsDirectory_kwd l::LParen_t e1::Expr c::Comma_t e2::Expr r::RParen_t
{
  top.isConstant = true;
  top.isChild = false;
  top.dataName = "";
  
  top.baseType = top.typerep;
  top.lastAccess = [];
  top.possibleAgnosis = [];
  top.agnosis = e1.agnosis +++ e1.lastAccess +++ e2.agnosis +++ e2.lastAccess;
}

aspect production readFunction
top::Expr ::= r::ReadFile_kwd l::LParen_t e1::Expr c::Comma_t e2::Expr rp::RParen_t
{
  top.isConstant = true;
  top.isChild = false;
  top.dataName = "";
  
  top.baseType = top.typerep;
  top.lastAccess = [];
  top.possibleAgnosis = [];
  top.agnosis = e1.agnosis +++ e1.lastAccess +++ e2.agnosis +++ e2.lastAccess;
}

aspect production cwdFunction
top::Expr ::= c::CWD_kwd l::LParen_t e::Expr r::RParen_t
{
  top.isConstant = true;
  top.isChild = false;
  top.dataName = "";
  
  top.baseType = top.typerep;
  top.lastAccess = [];
  top.possibleAgnosis = [];
  top.agnosis = e.agnosis +++ e.lastAccess;
}

aspect production envVarFunction
top::Expr ::= e::EnvVar_kwd l::LParen_t e1::Expr c::Comma_t e2::Expr r::RParen_t
{
  top.isConstant = true;
  top.isChild = false;
  top.dataName = "";
  
  top.baseType = top.typerep;
  top.lastAccess = [];
  top.possibleAgnosis = [];
  top.agnosis = e1.agnosis +++ e1.lastAccess +++ e2.agnosis +++ e2.lastAccess;
}

aspect production systemFunction
top::Expr ::= s::System_kwd l::LParen_t e1::Expr c::Comma_t e2::Expr r::RParen_t
{
  top.isConstant = true;
  top.isChild = false;
  top.dataName = "";
  
  top.baseType = top.typerep;
  top.lastAccess = [];
  top.possibleAgnosis = [];
  top.agnosis = e1.agnosis +++ e1.lastAccess +++ e2.agnosis +++ e2.lastAccess;
}

aspect production writeFunction
top::Expr ::= w::WriteFile_kwd l::LParen_t e1::Expr c1::Comma_t e2::Expr c2::Comma_t e3::Expr r::RParen_t
{  
  top.isConstant = true;
  top.isChild = false;
  top.dataName = "";
  
  top.baseType = top.typerep;
  top.lastAccess = [];
  top.possibleAgnosis = [];
  top.agnosis = e1.agnosis +++ e1.lastAccess +++ e2.agnosis +++ e2.lastAccess +++ e3.agnosis +++ e3.lastAccess;
}

aspect production appendFunction
top::Expr ::= a::AppendFile_kwd l::LParen_t e1::Expr c1::Comma_t e2::Expr c2::Comma_t e3::Expr r::RParen_t
{
  top.isConstant = true;
  top.isChild = false;
  top.dataName = "";
  
  top.baseType = top.typerep;
  top.lastAccess = [];
  top.possibleAgnosis = [];
  top.agnosis = e1.agnosis +++ e1.lastAccess +++ e2.agnosis +++ e2.lastAccess +++ e3.agnosis +++ e3.lastAccess;
}

aspect production printFunction
top::Expr ::= p::Print_kwd l::LParen_t e1::Expr c::Comma_t e2::Expr r::RParen_t
{
  top.isConstant = true;
  top.isChild = false;
  top.dataName = "";
  
  top.baseType = top.typerep;
  top.lastAccess = [];
  top.possibleAgnosis = [];
  top.agnosis = e1.agnosis +++ e1.lastAccess +++ e2.agnosis +++ e2.lastAccess;
}

aspect production listContentsFunction
top::Expr ::= li::ListContents_kwd l::LParen_t e1::Expr c::Comma_t e2::Expr r::RParen_t
{
  top.isConstant = true;
  top.isChild = false;
  top.dataName = "";
  
  top.baseType = top.typerep;
  top.lastAccess = [];
  top.possibleAgnosis = [];
  top.agnosis = e1.agnosis +++ e1.lastAccess +++ e2.agnosis +++ e2.lastAccess;
}

aspect production unsafeIOFunction
top::Expr ::= u::UnsafeIO_kwd
{  
  top.isConstant = true;
  top.isChild = false;
  top.dataName = "";
  
  top.baseType = top.typerep;
  top.lastAccess = [];
  top.possibleAgnosis = [];
  top.agnosis = [];
}

aspect production genIntFunction
top::Expr ::= g::GenInt_kwd l::LParen_t r::RParen_t
{
  top.isConstant = true;
  top.isChild = false;
  top.dataName = "";
  
  top.baseType = top.typerep;
  top.lastAccess = [];
  top.possibleAgnosis = [];
  top.agnosis = [];
}