grammar silver:analysis:typechecking:core;
import silver:base;
import core;

aspect production run
top::RunUnit ::= iIn::IO args::String p::Production(Root ::= String)
{
  postOps <- if a.noTypeChecking then [] else [printAllTypeErrors(grammars)]; 
}

abstract production printAllTypeErrors
top::Unit ::= specs::[GrammarSpec]
{
  forwards to printAllTypeErrorsHelp(specs)
	with {
		ioIn = print("Checking Type Errors.\n", top.ioIn);
	};
}

abstract production printAllTypeErrorsHelp
top::Unit ::= specs::[GrammarSpec]
{
  local attribute es :: String;
  es = head(specs).rootSpec.typeErrors;

  local attribute i :: IO;
  i = if es == "" then top.ioIn else print("Type Errors for : " ++ head(specs).name ++ "\n" ++ es ++ "\n\n", top.ioIn);

  local attribute recurse :: Unit;
  recurse = printAllTypeErrorsHelp(tail(specs));
  recurse.ioIn = i;

  top.io = if null(specs) then top.ioIn else recurse.io;

  top.code = if null(specs) || (es == "" && recurse.code == 0)
	     then 0 
	     else -1;

  top.order = 1;
}