grammar silver:analysis:typechecking:core;
import silver:base;

synthesized attribute typeErrors :: String;

attribute typeErrors occurs on Root, AGDcls, AGDcl;

aspect production root
top::Root ::= gdcl::GrammarDcl ims::ImportExportStmts  ags::AGDcls
{
  local attribute tes :: String;
  tes = ags.typeErrors;

  top.typeErrors = if tes == "" then tes else ("******" ++ top.fileName ++ "******\n" ++ tes);
}

aspect production agDclsOne
top::AGDcls ::= ag::AGDcl
{
  top.typeErrors = ag.typeErrors;
}

aspect production agDclsCons
top::AGDcls ::= h::AGDcl t::AGDcls
{
  top.typeErrors = h.typeErrors ++ t.typeErrors;
}


aspect production agDclSeq
top::AGDcl ::= ag1::AGDcl ag2::AGDcl
{
  top.typeErrors = ag1.typeErrors ++ ag2.typeErrors;
}

aspect production agDclNone
top::AGDcl ::=
{
  top.typeErrors = "";
}


