grammar silver:base:core;

terminal Occurs_kwd      / occurs /      lexer precedence = 5 ;
terminal On_kwd          / on /          lexer precedence = 5 ;

concrete production attributionDcl
top::AGDcl ::= at::Attribute_kwd a::QName oc::Occurs_kwd o::On_kwd nt::QName s::Semi_t
{
  top.location = "[line: " ++ toString(at.line) ++ ", column: " ++ toString(at.column) ++ "] ";
  top.pp = "attribute " ++ a.name ++ " occurs on " ++ nt.name ++ " ;" ;

  top.defs = addOccursDcl(afName, nfName, emptyDefs());
  top.globalDefs = addOccursDcl(afName, nfName, emptyDefs());

  local attribute er1 :: String;
  er1 = if null(attrs)
	then top.location ++ "Error: Attribute '" ++ a.name ++ "' is not declared.\n" 
	else "";

  local attribute er2 :: String;
  er2 = if null(types)
	then top.location ++ "Error: Nonterminal '" ++ nt.name ++ "' is not declared.\n" 
	else "";

  top.errors = er1 ++ er2;

  production attribute afNames :: [Decorated EnvItem];
  afNames = getFullNameDclOne(a.name, top.env);

  production attribute afName :: String;
  afName = if !null(afNames) then head(afNames).fullName else "FULL_NAME_NOT_DEFINED";

  production attribute nfNames :: [Decorated EnvItem];
  nfNames = getFullNameDclOne(nt.name, top.env);

  production attribute nfName :: String;
  nfName = if !null(nfNames) then head(nfNames).fullName else "FULL_NAME_NOT_DEFINED";

  local attribute attrs :: [Decorated EnvItem];
  attrs = getAttributeDclOne(afName, top.env);

  local attribute types :: [Decorated EnvItem];
  types = getTypeDclOne(nfName, top.env);
}
