grammar silver:base:core;


closed nonterminal QName with { pp, name, location, grammarName, env} ;

-- is the full name of the QName
synthesized attribute name :: String;

concrete production qNameId
top::QName ::= id::Id_t
{
  top.pp = id.lexeme;
  top.name = id.lexeme;
  top.location = "[line: " ++ toString(id.line) ++ ", column: " ++ toString(id.column) ++ "] ";
}

concrete production qNameCons
top::QName ::= id::Id_t c::Colon_t qn::QName
{
  top.pp = id.lexeme ++ ":" ++ qn.pp;
  top.name = id.lexeme ++ ":" ++ qn.name;
  top.location = "[line: " ++ toString(id.line) ++ ", column: " ++ toString(id.column) ++ "] ";
}


concrete production qNameProduction
top::QName ::= id::Production_kwd
{
  top.pp = "production";
  top.name = "production";
  top.location = "[line: " ++ toString(id.line) ++ ", column: " ++ toString(id.column) ++ "] ";
}

function makeQName
QName ::= s::String
{
  local attribute i ::Integer;
  i = indexof(":", s);

  return if i == -1
	 then qNameId(terminal(Id_t, s))
	 else qNameCons(terminal(Id_t, substring(0, i, s)), terminal(Colon_t, ":"), makeQName(substring(i+1, length(s), s)));
}