grammar silver:base:core;
import core;

closed nonterminal RootSpec with {exportedDefs, errors, includedGrammars, globalDefs, defs, exportedEnv};

synthesized attribute exportedEnv :: Decorated Env;

abstract production emptyRootSpec
top::RootSpec ::= 
{
  top.errors = "";
  top.includedGrammars = [];
  top.defs = emptyDefs();
  top.exportedDefs = emptyDefs();
  top.exportedEnv = emptyEnv();
  top.globalDefs = emptyDefs();
}

abstract production consRootSpec
top::RootSpec ::= c1::Decorated Root c2::Decorated RootSpec
{
  top.errors = c1.errors ++ c2.errors;
  top.includedGrammars = c1.includedGrammars +++ c2.includedGrammars;
  top.defs = appendDefs(c1.defs, c2.defs);
  top.exportedDefs = appendDefs(c1.exportedDefs, c2.exportedDefs);
  top.exportedEnv = toEnv(top.exportedDefs);
  top.globalDefs = appendDefs(c1.globalDefs, c2.globalDefs);
}

abstract production appendRootSpec
top::RootSpec ::= c1::Decorated RootSpec c2::Decorated RootSpec
{
  top.errors = c1.errors ++ c2.errors;
  top.includedGrammars = c1.includedGrammars +++ c2.includedGrammars;
  top.defs = appendDefs(c1.defs, c2.defs);
  top.exportedDefs = appendDefs(c1.exportedDefs, c2.exportedDefs);
  top.exportedEnv = toEnv(top.exportedDefs);
  top.globalDefs = appendDefs(c1.globalDefs, c2.globalDefs);
}

