grammar edu:umn:cs:melt:sandbox:BinaryTree ;

nonterminal ScopeEnvTree with envTrees, isEmpty;

synthesized attribute envTrees :: [Decorated EnvTree] ;

-- Productions for constructing an EnvTree
function emptyScopeEnvTree
Decorated ScopeEnvTree ::=
{
  return decorate internal_emptyScopeEnvTree() with {};
}

abstract production internal_emptyScopeEnvTree
et::ScopeEnvTree ::= 
{
 et.envTrees = [];
}

function oneScopeEnvTree
Decorated ScopeEnvTree ::= eis::Decorated EnvTree
{
  return decorate internal_oneScopeEnvTree(eis) with {};
}

abstract production internal_oneScopeEnvTree
et::ScopeEnvTree ::= eis::Decorated EnvTree
{
 et.envTrees = [eis] ;
}

function appendScopeEnvTree
Decorated ScopeEnvTree ::= l::Decorated ScopeEnvTree r::Decorated ScopeEnvTree
{
  return decorate internal_appendScopeEnvTree(l, r) with {};
}
abstract production internal_appendScopeEnvTree
et::ScopeEnvTree ::=  l::Decorated ScopeEnvTree r::Decorated ScopeEnvTree
{
 et.envTrees = l.envTrees +++ r.envTrees;
}


function consScopeEnvTree
Decorated ScopeEnvTree ::= l::Decorated EnvTree r::Decorated ScopeEnvTree
{
  return decorate internal_consScopeEnvTree(l, r) with {};
}
abstract production internal_consScopeEnvTree
et::ScopeEnvTree ::= l::Decorated EnvTree  r::Decorated ScopeEnvTree
{
 et.envTrees = [l] +++ r.envTrees;
}


function getDclsScope
[Decorated EnvItem] ::= search::String e::Decorated ScopeEnvTree
{
  return getDclsScopeHelp(search, e.envTrees);
}

function getDclsScopeHelp
[Decorated EnvItem] ::= search::String e::[Decorated EnvTree]
{
  return if null(e) then [] else getDcls(search, head(e)) +++ getDclsScopeHelp(search, tail(e));
}

function searchScopeEnvTree
[Decorated EnvItem] ::= search::String s::EnvSearch e::Decorated ScopeEnvTree
{
  return searchScopeEnvTreeHelp(search, s'', e.envTrees);
}

function searchScopeEnvTreeHelp
[Decorated EnvItem] ::= search::String s::EnvSearch e::[Decorated EnvTree]
{
  return if null(e)
         then [ ]    
         else searchEnvTree(search, s'', head(e)) +++ searchScopeEnvTreeHelp(search, s'', tail(e));
}

function flattenScope
[Decorated EnvItem] ::= t::Decorated ScopeEnvTree {
  return flattenScopeHelp(t.envTrees);
}


function flattenScopeHelp
[Decorated EnvItem] ::= t::[Decorated EnvTree] {
  return if null(t) then [] else flatten(head(t)) +++ flattenScopeHelp(tail(t));
}
