grammar silver:base:core;

--import silver:base:regex:abstractsyntax;

--import silver:base:regex:concretesyntax with parse as parse_regex;

-- Terminal Declarations
------------------------
terminal Terminal_kwd /terminal/ lexer precedence = 5;
concrete production terminalDcl
top::AGDcl ::= t::Terminal_kwd id::Id_t r::RegExpr s::Semi_t
{
  top.pp = "terminal " ++ id.lexeme ++ " " ++ r.pp++ ";";
  top.location = "[line: " ++ toString(t.line) ++ ", column: " ++ toString(t.column) ++ "] ";

  production attribute fName :: String;
  fName = top.grammarName.name ++ ":" ++ id.lexeme;

  top.defs = addTypeDcl(fName, termTypeRep(fName), 
	     addFullNameDcl(id.lexeme, fName,
	     addOccursDcl("lexeme", fName,
 	     addOccursDcl("line", fName,
	     addOccursDcl("column", fName, emptyDefs())))));

  top.globalDefs = addTypeDcl(fName, termTypeRep(fName),
	           addOccursDcl("lexeme", fName,
 	           addOccursDcl("line", fName,
	           addOccursDcl("column", fName, emptyDefs()))));

  local attribute er1 :: String;
  er1 = if length(getFullNameDcl(id.lexeme, top.env)) > 1
       then top.location ++ "Error: Name '" ++ id.lexeme ++ "' is already bound.\n"
       else "";	

  local attribute er2 :: String;
  er2 = if length(getTypeDcl(fName, top.env)) > 1
       then top.location ++ "Error: Type '" ++ fName ++ "' is already bound.\n"
       else "";	

  top.errors = er1 ++ er2;
}
nonterminal RegExpr with {pp, location, regexpr};
synthesized attribute regexpr :: String;

concrete production regExpr
top::RegExpr ::= r::RegExpr_t
{
  top.location = "[line: " ++ toString(r.line) ++ ", column: " ++ toString(r.column) ++ "] ";

-- Each scanner generator must define an aspect to this production and
-- define the attributes  regexpr and pp.

-- Specs below have been moved to scanner generator specific grammars.
--  Copper related specs are in  silver:translation:haskelljava:core


--
--  production attribute useRegexParser :: Boolean;
--  production attribute parsedRegexToUse :: String;
--  production attribute rabst :: Regex_abst;
--
---- Choose one of these two, depending on whether you wish to use
---- the regex compiler or output regex lexemes to the parser generator raw.
-----------------------
----  useRegexParser = false;
----  useRegexParser = true;
-----------------------
--
--  rabst = parse_regex(r.lexeme).regexpr_abst;
--
---- Choose one of these three, depending on which Silver-compiler
---- is being compiled.
------------------------
----  parsedRegexToUse = rabst.alex_regexpr;
----  parsedRegexToUse = rabst.lex_regexpr;
----  parsedRegexToUse = rabst.copper_regexpr;
------------------------
--
--  top.pp = if useRegexParser
--           then rabst.regex_pp
--           else r.lexeme;
--
--  top.regexpr = if useRegexParser
--                then parsedRegexToUse
--                else r.lexeme;
--
--
}




