grammar silver:base:cs:default;

function tsMergeSort
[TerminalSpec] ::= c1::[TerminalSpec]
{
  return tsMergeSortHelp(mapTerminalDclsList(c1));
}

function tsMergeSortHelp
[TerminalSpec] ::= c1::[[TerminalSpec]]
{
  return if null(c1) then []
         else if null(tail(c1)) then head(c1)
         else tsMergeSortHelp(tsMergePairs(c1));
}

function tsMergePairs
[[TerminalSpec]] ::= c1::[[TerminalSpec]]
{
  return if null(c1) then []
         else if null(tail(c1)) then c1
         else cons(mergeTerminalDclsList(head(c1), head(tail(c1))), tsMergePairs(tail(tail(c1))));
}

function mergeTerminalDclsList
[TerminalSpec] ::= tds1::[TerminalSpec] tds2::[TerminalSpec]
{
  return if null(tds2)
         then tds1
         else if null(tds1)
         then tds2
         else if  head(tds1).lexerPrecedence  <  head(tds2).lexerPrecedence
              then cons( head(tds2) , merge_tds1_tds2_tail )
              else cons( head(tds1) , merge_tds1_tail_tds2 ) ;

  local attribute merge_tds1_tds2_tail :: [TerminalSpec] ;
  merge_tds1_tds2_tail = mergeTerminalDclsList( tds1, tail(tds2) ) ;

  local attribute merge_tds1_tail_tds2 :: [TerminalSpec] ;
  merge_tds1_tail_tds2 = mergeTerminalDclsList( tail(tds1), tds2 ) ;

}

function mapTerminalDclsList
[[TerminalSpec]] ::= tds1::[TerminalSpec]
{
  return if null(tds1)
         then []
         else cons([head(tds1)], mapTerminalDclsList(tail(tds1)));
}
