grammar silver:base:cs:default;
import silver:base:core;

terminal Start_kwd / start / lexer precedence = 5 ;

synthesized attribute hasStartSymbol :: Boolean;
synthesized attribute startName :: String;


concrete production startNonterminalDcl
top::AGDcl ::= st::Start_kwd n::NonTerminal_kwd id::Id_t  s::Semi_t
{
  production attribute extraDcls :: AGDcl with agDclSeq;
  extraDcls := defaultStartNonterminalDcl(id);

  forwards to extraDcls'';
}

abstract production defaultStartNonterminalDcl
top::AGDcl ::= id::Id_t
{
  top.pp = "start nonterminal " ++ id.lexeme ++ ";";
  
  production attribute fName :: String;
  fName = top.grammarName.name ++ ":" ++ id.lexeme;

  top.defs = addTypeDcl(fName, ntTypeRep(fName), 
	     addFullNameDcl(id.lexeme, fName,
             addValueDcl(top.grammarName.name ++ ":" ++ "parse", 
			     prodTypeRep([stringTypeRep()], ntTypeRep(fName)),
             addFullNameDcl("parse", top.grammarName.name ++ ":" ++ "parse",
	     emptyDefs()))));
	       

  top.globalDefs =  
	     addTypeDcl(fName, ntTypeRep(fName), 
	     addValueDcl(top.grammarName.name ++ ":" ++ "parse", 
			     prodTypeRep([stringTypeRep()], ntTypeRep(fName)),
	     emptyDefs()));

  top.hasStartSymbol = true; 
  top.startName = fName;

  forwards to nonterminalDcl(terminal(NonTerminal_kwd, "nonterminal"), id, terminal(Semi_t, ""));
}


aspect production defaultNonterminalDcl
top::AGDcl ::= id::Id_t
{
  top.hasStartSymbol = false; 

  top.parserUses = [];
  top.terminalDcls = [];
  top.ruleDcls = [];
}

aspect production closedNonterminalDcl
top::AGDcl ::= c::Closed_kwd n::NonTerminal_kwd  id::Id_t  s::Semi_t
{
  top.hasStartSymbol = false; 

  top.parserUses = [];
  top.terminalDcls = [];
  top.ruleDcls = [];
}

aspect production closeNonterminalDcl
top::AGDcl ::= c::Close_kwd q::QName  s::Semi_t
{
  top.hasStartSymbol = false; 

  top.parserUses = [];
  top.terminalDcls = [];
  top.ruleDcls = [];
}
