grammar silver:base:cs:default;
import silver:base:core;

attribute startName occurs on RootSpec;
attribute hasStartSymbol occurs on RootSpec;

aspect production emptyRootSpec
top::RootSpec ::= 
{
  top.hasStartSymbol = false;
  top.startName = "";

  top.parserUses = [];
  top.terminalDcls = [];
  top.ruleDcls = [];
  top.hiddenSyntax = [];
}

aspect production consRootSpec
top::RootSpec ::= c1::Decorated Root c2::Decorated RootSpec
{
  top.hasStartSymbol = c1.hasStartSymbol || c2.hasStartSymbol;
  top.startName = if c1.hasStartSymbol then c1.startName else c2.startName;

  top.parserUses = c1.parserUses ++ c2.parserUses;
  top.terminalDcls = c1.terminalDcls +++ c2.terminalDcls;
  top.ruleDcls = c1.ruleDcls +++ c2.ruleDcls;
  top.hiddenSyntax = c1.hiddenSyntax +++ c2.hiddenSyntax;
}

aspect production appendRootSpec
top::RootSpec ::= c1::Decorated RootSpec c2::Decorated RootSpec
{
  top.hasStartSymbol = c1.hasStartSymbol || c2.hasStartSymbol;
  top.startName = if c1.hasStartSymbol then c1.startName else c2.startName;

  top.parserUses = c1.parserUses ++ c2.parserUses;
  top.terminalDcls = c1.terminalDcls +++ c2.terminalDcls;
  top.ruleDcls = c1.ruleDcls +++ c2.ruleDcls;
  top.hiddenSyntax = c1.hiddenSyntax +++ c2.hiddenSyntax;
}

