grammar silver:base:cs:default;

import silver:base:core;

synthesized attribute grammarNameSyn :: Decorated QName;
attribute grammarNameSyn occurs on RHSSpec;

nonterminal RuleSpec with {ruleLHS, ruleRHSSpec};
nonterminal RHSSpec with {ruleRHS, ruleName, parserPrecedence};

synthesized attribute ruleName :: String;
synthesized attribute ruleLHS :: String;
synthesized attribute ruleRHS :: [String];
synthesized attribute ruleRHSSpec :: [RHSSpec];

abstract production ruleSpec
top::RuleSpec ::= l::String ns::[RHSSpec]
{
  top.ruleLHS = l;
  top.ruleRHSSpec = ns;
}

abstract production rhsSpec
top::RHSSpec ::= fn::String ns::[String] gName::Decorated QName m::Decorated OptProductionModifiers
{
  top.ruleName = fn;
  top.ruleRHS = ns;
  top.grammarNameSyn = gName;
  top.parserPrecedence = m.parserPrec;
}

function mergeRules
[RuleSpec] ::= c1::[RuleSpec]
{
  return if null(c1)
	 then []
	 else mergeRuleSpec(head(c1), mergeRules(tail(c1)));
}

function mergeRuleSpec
[RuleSpec] ::= c1::RuleSpec c2::[RuleSpec]
{
  return if null(c2) then [c1'']
         else if head(c2).ruleLHS == c1.ruleLHS
	      then cons(ruleSpec(c1.ruleLHS, head(c2).ruleRHSSpec +++ c1.ruleRHSSpec), tail(c2))
	      else cons(head(c2), mergeRuleSpec(c1'', tail(c2)));
}

