grammar silver:base:cs:default;
import silver:utils;


nonterminal FilterResult with {terminalDcls, ruleDcls};
abstract production filterSyntax
top::FilterResult ::= ns::[String] tdcls::[TerminalSpec] rdcls::[RuleSpec]
{
  top.terminalDcls = filterTerminalDcls(ns, tdcls);
  top.ruleDcls = filterRuleDcls(ns, rdcls);
}

function filterRuleDcls
[RuleSpec] ::= ns::[String] rdcls::[RuleSpec]
{
  return if null(ns)
         then rdcls
	 else removeRule(head(ns), filterRuleDcls(tail(ns), rdcls));
}
function removeRule
[RuleSpec] ::= n::String rdcls::[RuleSpec]
{
  local attribute filteredRhs :: [RHSSpec];
  filteredRhs = filterRuleRhs(n, head(rdcls).ruleRHSSpec);

  local attribute newSpec :: RuleSpec;
  newSpec = ruleSpec(head(rdcls).ruleLHS, filteredRhs);

  return if null(rdcls)
	 then []
	 else if (head(rdcls).ruleLHS == n || null(filteredRhs))
	      then removeRule(n, tail(rdcls))
	      else cons(newSpec'', removeRule(n, tail(rdcls)));
}

function filterRuleRhs
[RHSSpec] ::= n::String sl::[RHSSpec]{

 return if null(sl)
	 then []
	 else if head(sl).ruleName == n || containsString(n, head(sl).ruleRHS)
	      then filterRuleRhs(n, tail(sl))
	      else cons(head(sl), filterRuleRhs(n, tail(sl)));
}

function filterTerminalDcls
[TerminalSpec] ::= ns::[String] tdcls::[TerminalSpec]
{
  return if null(ns) 
         then tdcls
	 else removeTerminal(head(ns), filterTerminalDcls(tail(ns), tdcls));
}
function removeTerminal
[TerminalSpec] ::= n::String tdcls::[TerminalSpec]
{
  return if null(tdcls)
	 then []
	 else if head(tdcls).terminalName == n
	      then removeTerminal(n, tail(tdcls))
	      else cons(head(tdcls), removeTerminal(n, tail(tdcls)));
}
