grammar silver:base:cs:default;
import silver:base:core;

terminal Ignore_kwd /ignore/ lexer precedence = 5;

terminal Left_kwd /left/ lexer precedence = 5;
terminal Association_kwd /association/ lexer precedence = 5;
terminal Right_kwd /right/ lexer precedence = 5;
terminal None_kwd /none/ lexer precedence = 5;
terminal Precedence_kwd /precedence/ lexer precedence = 5;
terminal Lexer_kwd /lexer/ lexer precedence = 5;

aspect production terminalDcl
top::AGDcl ::= t::Terminal_kwd id::Id_t r::RegExpr s::Semi_t
{
  top.hasStartSymbol = false;

  top.terminalDcls = [terminalSpec(fName, false, r.regexpr)];			   
  top.parserUses = [];
  top.ruleDcls = [];
}

concrete production terminalDclModifiers
top::AGDcl ::= t::Terminal_kwd id::Id_t r::RegExpr tm::TerminalModifiers s::Semi_t
{
  production attribute fName ::String;
  fName = top.grammarName.name ++ ":" ++ id.lexeme;

  top.pp = "terminal " ++ id.lexeme ++ " " ++ r.pp ++ "\n  " ++ tm.pp ++ ";";

--<<<<<<< TerminalDcl.sv
--  top.terminalDcls = [longTerminalSpec(fName, tm.lexerPrec, tm           .parserPrec, tm.parserAssoc, r.regexpr)];
--=======
--  top.terminalDcls = [longTerminalSpec(fName, false, tm, r.regexpr)];
-->>>>>>> 1.5

  top.terminalDcls = [longTerminalSpec(fName, false, tm, r.regexpr)];

  forwards to terminalDcl(t, id, r'', s);
}

concrete production terminalDclKwdModifiers
top::AGDcl ::= i::Ignore_kwd t::Terminal_kwd id::Id_t r::RegExpr s::Semi_t
{
  production attribute fName ::String;
  fName = top.grammarName.name ++ ":" ++ id.lexeme;

  top.pp = "ignore terminal " ++ id.lexeme ++ " " ++ r.pp ++ ";";

  top.terminalDcls = [terminalSpec(fName, true, r.regexpr)];

  forwards to terminalDcl(t, id, r'', s);
}

concrete production terminalDclAllModifiers
top::AGDcl ::= i::Ignore_kwd t::Terminal_kwd id::Id_t r::RegExpr tm::TerminalModifiers s::Semi_t
{
  production attribute fName ::String;
  fName = top.grammarName.name ++ ":" ++ id.lexeme;

  top.pp = " ignore terminal " ++ id.lexeme ++ " " ++ r.pp ++ "\n  " ++ tm.pp ++ ";";

  top.terminalDcls = [longTerminalSpec(fName, true, tm, r.regexpr)];
  forwards to terminalDcl(t, id, r'', s);
}

synthesized attribute hasLexerPrec :: Boolean ;
synthesized attribute hasParserPrec :: Boolean ;
synthesized attribute hasParserAssoc :: Boolean ;

synthesized attribute lexerPrec :: Integer ;
synthesized attribute parserPrec :: Integer ;
synthesized attribute parserAssoc :: String ;

nonterminal TerminalModifiers with {pp, hasLexerPrec, lexerPrec, hasParserPrec, parserPrec, hasParserAssoc, parserAssoc};
nonterminal TerminalModifier with {pp, hasLexerPrec, lexerPrec, hasParserPrec, parserPrec, hasParserAssoc, parserAssoc};

concrete production terminalModifierSingle
top::TerminalModifiers ::= tm::TerminalModifier
{
  top.pp = tm.pp;

  top.hasLexerPrec = tm.hasLexerPrec ;
  top.lexerPrec = tm.lexerPrec ;

  top.hasParserPrec = tm.hasParserPrec ;
  top.parserPrec = tm.parserPrec ;

  top.hasParserAssoc = tm.hasParserAssoc ;
  top.parserAssoc = tm.parserAssoc ;
}

concrete production terminalModifiersCons
top::TerminalModifiers ::= h::TerminalModifier c::Comma_t t::TerminalModifiers
{
  top.pp = h.pp ++ ",\n " ++ t.pp;

  top.hasLexerPrec = h.hasLexerPrec || t.hasLexerPrec ;
  top.lexerPrec = if   h.hasLexerPrec 
                  then h.lexerPrec 
                  else if   t.hasLexerPrec
                       then t.lexerPrec 
                       else 0 ;

  top.hasParserPrec = h.hasParserPrec || t.hasParserPrec ;
  top.parserPrec = if   h.hasParserPrec 
                   then h.parserPrec 
                   else if t.hasParserPrec
                        then t.parserPrec 
                        else 0 ;

  top.hasParserAssoc = h.hasParserAssoc || t.hasParserAssoc ;
  top.parserAssoc = if   h.hasParserAssoc 
                    then h.parserAssoc 
                    else if   t.hasParserAssoc
                         then t.parserAssoc 
                         else "nonassoc" ;
}

concrete production terminalModifierLeft
top::TerminalModifier ::= a::Association_kwd e::Equal_t l::Left_kwd
{
  top.pp = "association = left";
 
  top.hasLexerPrec = false ;
  top.lexerPrec = 0 ;

  top.hasParserPrec = false ;
  top.parserPrec = 0 ;

  top.hasParserAssoc = true ;
  top.parserAssoc = "left" ;

  forwards to terminalModifierDefaults();
}

concrete production terminalModifierRight
top::TerminalModifier ::= a::Association_kwd e::Equal_t r::Right_kwd
{
  top.pp = "association = right";

  top.hasLexerPrec = false ;
  top.lexerPrec = 0 ;

  top.hasParserPrec = false ;
  top.parserPrec = 0 ;

  top.hasParserAssoc = true ;
  top.parserAssoc = "right" ;

  forwards to terminalModifierDefaults();
}

concrete production terminalModifierNone
top::TerminalModifier ::= a::Association_kwd e::Equal_t n::None_kwd
{
  top.pp = "association = none";

  top.hasLexerPrec = false ;
  top.lexerPrec = 0 ;

  top.hasParserPrec = false ;
  top.parserPrec = 0 ;

  top.hasParserAssoc = false ;
  top.parserAssoc = "nonassoc" ;

  forwards to terminalModifierDefaults();
}

concrete production terminalModifierPrecedence
top::TerminalModifier ::= p::Precedence_kwd e::Equal_t i::Int_t
{
  top.pp = "precedence = " ++ i.lexeme;

  top.hasLexerPrec = false ;
  top.lexerPrec = 0 ;

  top.hasParserPrec = true ;
  top.parserPrec = toInt(i.lexeme) ;

  top.hasParserAssoc = false ;
  top.parserAssoc = "nonassoc" ;

  forwards to terminalModifierDefaults();
}

concrete production terminalModifierLexerPrecedence
top::TerminalModifier ::= l::Lexer_kwd p::Precedence_kwd e::Equal_t i::Int_t
{
  top.pp = "lexer precedence = " ++ i.lexeme;

  top.hasLexerPrec = true ;
  top.lexerPrec = toInt (i.lexeme) ;

  top.hasParserPrec = false ;
  top.parserPrec = 0 ;

  top.hasParserAssoc = false ;
  top.parserAssoc = "nonassoc" ;

  forwards to terminalModifierDefaults();
}

abstract production terminalModifierDefaults
top::TerminalModifier ::= 
{
  top.pp = "";

  top.hasLexerPrec = false;
  top.lexerPrec = 0;

  top.hasParserPrec = false;
  top.parserPrec = 0;

  top.hasParserAssoc = false;
  top.parserAssoc = "nonassoc";
}
