grammar silver:base:type:anytype;
import silver:base:core;
import core;

terminal AnyType_kwd / AnyType /  lexer precedence = 5 ;

synthesized attribute isAnyType :: Boolean;
attribute isAnyType occurs on TypeRep;

concrete production anyType
top::Type ::= t_kwd::AnyType_kwd
{
 top.pp = "AnyType" ;
 top.typerep = anyTypeTypeRep();
 top.errors = "";
 top.location = "[line: " ++ toString(t_kwd.line) ++ ", column: " ++ toString(t_kwd.column) ++ "] ";
}

function anyTypeTypeRep
Decorated TypeRep ::= 
{
  return decorate internal_anyTypeTypeRep() with {};
}

abstract production internal_anyTypeTypeRep
top::TypeRep ::= 
{
  top.pp = "AnyType" ;
  top.typeName = "AnyType";
  top.isAnyType = true ;
 
  top.typeEquals = anyTypeEquals;
  forwards to internal_defaultTypeRep();
}


abstract production anyTypeEquals
top::TypeEquals ::= t1::Decorated TypeRep t2::Decorated TypeRep
{
 top.bValue = t1.isAnyType && t2.isAnyType ;
}

aspect production internal_topTypeRep
top::TypeRep ::= 
{
  top.isAnyType = true;
}

aspect production internal_defaultTypeRep
top::TypeRep ::= 
{
  top.isAnyType = false;
}
