grammar silver:base:type:higherorder;
import silver:base:core;

-- Nonterminal, Terminal references
-----------------------------------
concrete production nttType
top::Type ::= q::QName
{
  top.pp = q.pp;
  top.typerep = if null(types) then topTypeRep() else head(types).typerep;
  top.location = q.location;

  top.errors = if null(types)
	       then top.location ++ "Error: '" ++ q.name ++ "' is not bound to a type.\n"
	       else "";

  production attribute fNames :: [Decorated EnvItem];
  fNames = getFullNameDclOne(q.name, top.env);

  production attribute fName :: String;
  fName = if !null(fNames) then head(fNames).fullName else "FULL_NAME_NOT_DEFINED";

  production attribute types :: [Decorated EnvItem];
  types = getTypeDclOne(fName, top.env);
}
