grammar silver:base:type:io;
import silver:base:core;
import core;

terminal IO_kwd 	/IO/ 	lexer precedence = 5;

synthesized attribute  isIO :: Boolean;
attribute isIO occurs on TypeRep;

concrete production ioType
top::Type ::= i::IO_kwd
{
 top.pp = "IO" ;
 top.typerep = ioTypeRep();
 top.location = "[line: " ++ toString(i.line) ++ ", column: " ++ toString(i.column) ++ "] ";
 top.errors = "";
}

function ioTypeRep
Decorated TypeRep ::= 
{
  return decorate internal_ioTypeRep() with {};
}

abstract production internal_ioTypeRep
top::TypeRep ::= 
{
  top.pp = "IO" ;
  top.typeName = "IO";
  top.isIO = true;

  top.typeEquals = ioEquals;
  forwards to internal_defaultTypeRep();
}

abstract production ioEquals
top::TypeEquals ::= t1::Decorated TypeRep t2::Decorated TypeRep
{
    top.bValue = t1.typeName == "TOP" || t2.typeName == "TOP" || (t1.isIO && t2.isIO);
}


aspect production internal_defaultTypeRep
top::TypeRep ::= 
{
  top.isIO = false;
}
