grammar silver:extension:convenience;
import silver:base;

synthesized attribute trans :: [Trans];
nonterminal ProductionDclStmts with {trans};
nonterminal ProductionDclStmt with {trans};

terminal Productions_kwd /productions/ lexer precedence = 5;


synthesized attribute transName :: Id_t;
synthesized attribute transSig :: ProductionSignature;
synthesized attribute transBody :: ProductionBody;
nonterminal Trans with {transName, transSig, transBody};

concrete production productionDclC
top::AGDcl ::= c::Concrete_kwd s::Productions_kwd l::LCurly_t stmts::ProductionDclStmts r::RCurly_t {

  forwards to buildCTrans(stmts.trans);
}

concrete production productionDclA
top::AGDcl ::= c::Abstract_kwd s::Productions_kwd l::LCurly_t stmts::ProductionDclStmts r::RCurly_t {

  forwards to buildATrans(stmts.trans);
}

concrete production productionDclStmtsOne
top::ProductionDclStmts ::= s::ProductionDclStmt {
  top.trans = s.trans;
}

concrete production productionDclStmtsCons
top::ProductionDclStmts ::= s::ProductionDclStmt ss::ProductionDclStmts {
  top.trans = s.trans ++ ss.trans;
}

concrete production productionDclStmt
top::ProductionDclStmt ::= id::Id_t ns::ProductionSignature b::ProductionBody {
  top.trans = [makeTrans(id, ns'', b'')];
}

function buildCTrans
AGDcl ::= t::[Trans] {
  return if null(t)
	 then agDclNone()
	 else agDclSeq(concreteProductionDcl(terminal(Concrete_kwd, "concrete"), terminal(Production_kwd, "production"), head(t).transName,
  				    head(t).transSig, optProductionModifiersNothing(),
				    head(t).transBody), buildCTrans(tail(t)));
}

function buildATrans
AGDcl ::= t::[Trans] {
  return if null(t)
	 then agDclNone()
	 else agDclSeq(productionDcl(terminal(Abstract_kwd, "abstract"), terminal(Production_kwd, "production"), head(t).transName,
  				    head(t).transSig, head(t).transBody), buildATrans(tail(t)));
}

abstract production makeTrans
top::Trans ::= i::Id_t s::ProductionSignature b::ProductionBody {
  top.transName = i;
  top.transSig = s'';
  top.transBody = b'';
}
