grammar silver:extension:let;
import silver:base;
import silver:analysis ;

--import silver:translation;
import silver:translation:ag:haskell ;

terminal Let_kwd /let/ lexer precedence = 5;
terminal In_kwd /in/ lexer precedence = 5;
terminal End_kwd /end/ lexer precedence = 5;

nonterminal LetAssigns with {pp, defs, haskell, env, signatureEnv, localsEnv, globalEnv, errors, typeErrors};
nonterminal AssignExpr with {pp, defs, haskell, env, signatureEnv, localsEnv, globalEnv, errors, typeErrors};

concrete production qNameLet
top::QName ::= id::Let_kwd
{
  forwards to qNameId(terminal(Id_t, "let", id.line, id.column));
}

concrete production letp
top::Expr ::= l::Let_kwd la::LetAssigns i::In_kwd e::Expr en::End_kwd
{

  top.haskell = "(let " ++ la.haskell ++ " in " ++ e.haskell ++ ")";

  top.errors = la.errors ++ e.errors ;
  top.typeErrors = la.typeErrors ++ e.typeErrors ;
  
  forwards to e'' with {env = appendDefsEnv(la.defs, top.env);};

  e.env = appendDefsEnv(la.defs, top.env);
}

concrete production assigns
top::LetAssigns ::= ae::AssignExpr comma::Comma_t list::LetAssigns
{
  top.pp = ae.pp ++ ", " ++ list.pp;
  top.haskell = ae.haskell ++ "; " ++ list.haskell;
  top.defs = appendDefs(ae.defs, list.defs);
  top.errors = ae.errors ++ list.errors ;
  top.typeErrors = ae.typeErrors ++ list.typeErrors ;
}

concrete production assignListSingle 
top::LetAssigns ::= ae::AssignExpr
{
  top.pp = ae.pp;
  top.haskell = ae.haskell;
  top.defs = ae.defs;
  top.errors = ae.errors ;
  top.typeErrors = ae.typeErrors ;

}

concrete production assignExpr
top::AssignExpr ::= id::Id_t eq::Equal_t e::Expr
{
  top.pp = id.lexeme ++ " = " ++ e.pp;
  top.haskell = "param_" ++ id.lexeme ++ " = " ++ e.haskell;
  top.defs = addFullNameDcl(id.lexeme, id.lexeme, addValueDcl(id.lexeme, e.typerep, emptyDefs()));
  e.userFriendly = 0 ;
  top.errors = e.errors ;
  top.typeErrors = e.typeErrors ;
}
