grammar silver:extension:list;
import silver:base;
import core;

aspect production root
top::Root ::= gdcl::GrammarDcl ims::ImportExportStmts  ags::AGDcls
{
  extraImports <- if top.declaredName.name == "lists:anytype" 
		  then importStmtsNone() 
 		  else importStmtsOne(importAll(terminal(Import_kwd, ""),
		  			        qNameCons(terminal(Id_t, "lists"), terminal(Colon_t, ""), qNameId(terminal(Id_t, "anytype"))),
				                withClauseEmpty(),
						terminal(Semi_t, "")));
}


aspect production run
top::RunUnit ::= iIn::IO args::String p::Production(Root ::= String)
{
  extraGrammars <-
   ["grammar lists:anytype;\n" ++ 
    "export lists:anytype ;\n" ++
    "closed nonterminal AnyTypeList ;\n" ++
    "\n" ++
    "synthesized attribute empty_AnyTypeList :: Boolean ;\n" ++
    "synthesized attribute head_AnyTypeList :: AnyType ;\n" ++
    "synthesized attribute tail_AnyTypeList :: Decorated AnyTypeList ;\n" ++
    "synthesized attribute length_AnyTypeList :: Integer ;\n" ++
    "\n" ++
    "attribute empty_AnyTypeList occurs on AnyTypeList ;\n" ++
    "attribute head_AnyTypeList occurs on AnyTypeList ;\n" ++
    "attribute tail_AnyTypeList occurs on AnyTypeList ;\n" ++
    "attribute length_AnyTypeList occurs on AnyTypeList ;\n" ++
    "\n" ++
    "function nil_AnyTypeList Decorated AnyTypeList ::= { return decorate internal_nil_AnyTypeList() with {}; }\n" ++
    "abstract production internal_nil_AnyTypeList\n" ++
    "l::AnyTypeList ::= \n" ++
    "{\n" ++
    "  l.empty_AnyTypeList = true ;\n" ++
    "  l.length_AnyTypeList = 0 ;\n" ++
    "  l.head_AnyTypeList = error (\"Accessing head on value of type [ ] not allowed.\\n\" );\n" ++
    "  l.tail_AnyTypeList = error (\"Accessing tail on value of type [ ] not allowed.\\n\" );\n" ++
    "}\n" ++
    "function cons_AnyTypeList Decorated AnyTypeList ::= h::AnyType t::Decorated AnyTypeList { return decorate internal_cons_AnyTypeList(h'', t) with{}; }\n" ++
    "abstract production internal_cons_AnyTypeList\n" ++
    "l::AnyTypeList ::= h::AnyType t::Decorated AnyTypeList\n" ++
    "{\n" ++
    "  l.empty_AnyTypeList = false ;\n" ++
    "  l.length_AnyTypeList = 1 + t.length_AnyTypeList ;\n" ++
    "  l.head_AnyTypeList = h ;\n" ++
    "  l.tail_AnyTypeList = t ;\n" ++
    "}\n" ++
    "function append_AnyTypeList\n" ++
    "Decorated AnyTypeList ::= l1::Decorated AnyTypeList l2::Decorated AnyTypeList\n" ++
    "{\n" ++
    "  return if l1.empty_AnyTypeList\n" ++
    "           then l2 \n" ++
    "           else cons_AnyTypeList ( l1.head_AnyTypeList ,\n" ++
    "                                   append_AnyTypeList ( l1.tail_AnyTypeList , l2 ) ) ;\n" ++
    "}\n"];

}
