{
module Module_silver_base_regex_concretesyntax_Scanner where
import Terminal
}
%wrapper "posn"
tokens :-
   [\+]
    { tok (\p s -> (Token_silver_base_regex_concretesyntax_Plus_t (mkAlexTerm p (count p s) s))) } 
   [\*]
    { tok (\p s -> (Token_silver_base_regex_concretesyntax_Kleene_t (mkAlexTerm p (count p s) s))) } 
   [\?]
    { tok (\p s -> (Token_silver_base_regex_concretesyntax_Optional_t (mkAlexTerm p (count p s) s))) } 
   [\|]
    { tok (\p s -> (Token_silver_base_regex_concretesyntax_Choice_t (mkAlexTerm p (count p s) s))) } 
   [\-]
    { tok (\p s -> (Token_silver_base_regex_concretesyntax_Range_t (mkAlexTerm p (count p s) s))) } 
   [\^]
    { tok (\p s -> (Token_silver_base_regex_concretesyntax_RegexNot_t (mkAlexTerm p (count p s) s))) } 
   [\[]
    { tok (\p s -> (Token_silver_base_regex_concretesyntax_RegexLBrack_t (mkAlexTerm p (count p s) s))) } 
   [\]]
    { tok (\p s -> (Token_silver_base_regex_concretesyntax_RegexRBrack_t (mkAlexTerm p (count p s) s))) } 
   [\(]
    { tok (\p s -> (Token_silver_base_regex_concretesyntax_RegexLParen_t (mkAlexTerm p (count p s) s))) } 
   [\)]
    { tok (\p s -> (Token_silver_base_regex_concretesyntax_RegexRParen_t (mkAlexTerm p (count p s) s))) } 
   [\.]
    { tok (\p s -> (Token_silver_base_regex_concretesyntax_RegexWildcard_t (mkAlexTerm p (count p s) s))) } 
   \\.
    { tok (\p s -> (Token_silver_base_regex_concretesyntax_EscapedChar_t (mkAlexTerm p (count p s) s))) } 
   .
    { tok (\p s -> (Token_silver_base_regex_concretesyntax_RegexChar_t (mkAlexTerm p (count p s) s))) } 


{

tok f p s = f p s
count :: AlexPosn->String->AlexPosn
count pos "" = pos
count (AlexPn abs_n line_n column_n) ('\n':cs) = count (AlexPn (abs_n+1) (line_n+1) 0 ) cs
count (AlexPn abs_n line_n column_n) (c:cs) = count (AlexPn (abs_n+1) line_n (column_n+1) ) cs

mkAlexTerm (AlexPn abs_begin line_begin column_begin)  (AlexPn abs_end line_end column_end) str
 = TERMINAL {syns_TERMINAL = SYNS_TERMINAL {attr_TERMINAL__lexeme = str, attr_TERMINAL__line = line_begin,attr_TERMINAL__column = column_begin}}

data Token =
    Token_silver_base_regex_concretesyntax_Plus_t TERMINAL |
    Token_silver_base_regex_concretesyntax_Kleene_t TERMINAL |
    Token_silver_base_regex_concretesyntax_Optional_t TERMINAL |
    Token_silver_base_regex_concretesyntax_Choice_t TERMINAL |
    Token_silver_base_regex_concretesyntax_Range_t TERMINAL |
    Token_silver_base_regex_concretesyntax_RegexNot_t TERMINAL |
    Token_silver_base_regex_concretesyntax_RegexLBrack_t TERMINAL |
    Token_silver_base_regex_concretesyntax_RegexRBrack_t TERMINAL |
    Token_silver_base_regex_concretesyntax_RegexLParen_t TERMINAL |
    Token_silver_base_regex_concretesyntax_RegexRParen_t TERMINAL |
    Token_silver_base_regex_concretesyntax_RegexWildcard_t TERMINAL |
    Token_silver_base_regex_concretesyntax_RegexChar_t TERMINAL |
    Token_silver_base_regex_concretesyntax_EscapedChar_t TERMINAL |
    TT_Err  AlexPosn
    deriving (Show)

}
