{
module Module_silver_utils_command_Scanner where
import Terminal
}
%wrapper "posn"
tokens :-
   [\-]([\-]?)[a-zA-Z0-9]+
    { tok (\p s -> (Token_silver_utils_command_Flag_t (mkAlexTerm p (count p s) s))) } 
   [\ \t]+
    ; 
   [^\-\ ][^\ ]*
    { tok (\p s -> (Token_silver_utils_command_Chunk_t (mkAlexTerm p (count p s) s))) } 


{

tok f p s = f p s
count :: AlexPosn->String->AlexPosn
count pos "" = pos
count (AlexPn abs_n line_n column_n) ('\n':cs) = count (AlexPn (abs_n+1) (line_n+1) 0 ) cs
count (AlexPn abs_n line_n column_n) (c:cs) = count (AlexPn (abs_n+1) line_n (column_n+1) ) cs

mkAlexTerm (AlexPn abs_begin line_begin column_begin)  (AlexPn abs_end line_end column_end) str
 = TERMINAL {syns_TERMINAL = SYNS_TERMINAL {attr_TERMINAL__lexeme = str, attr_TERMINAL__line = line_begin,attr_TERMINAL__column = column_begin}}

data Token =
    Token_silver_utils_command_Flag_t TERMINAL |
    Token_silver_utils_command_Chunk_t TERMINAL |
    Token_silver_utils_command_WhiteSpace_t TERMINAL |
    TT_Err  AlexPosn
    deriving (Show)

}
