grammar silver:translation:ag:haskelljava:core;
import silver:base;
import silver:utils;

aspect production stringLength
top::Expr ::= e::Expr
{
  top.haskell = "(length " ++ e.haskell ++ ")";
}

aspect production unknownLength
top::Expr ::= e::Expr
{
  top.haskell = "(-1)";
}

aspect production indexOfFunction
top::Expr ::= i::IndexOf_kwd l::LParen_t e1::Expr c::Comma_t e2::Expr r::RParen_t
{
  top.haskell =    "("
	     ++  "("
	     ++   "(\\f -> let x = f x in x)"
             ++   "(\\io->  (\\pat str index -> if str == \"\" then -1 else if isPrefixOf pat str then  index else io pat (tail str) (index+1))) "
             ++  ")"
	     ++   "( " ++ e1.haskell ++ ") ( " ++ e2.haskell ++ ") 0"
             ++ ")";
}
aspect production subStringFunction
top::Expr ::= s::SubString_kwd l::LParen_t e1::Expr c1::Comma_t e2::Expr c2::Comma_t e3::Expr r::RParen_t
{
  top.haskell = "((\\i j str -> drop i (take j str)) " ++ e1.haskell  ++ " " ++ e2.haskell  ++ " " ++ e3.haskell ++ ")";
}
aspect production errorFunction
top::Expr ::= er::Error_kwd l::LParen_t e::Expr r::RParen_t
{
  top.haskell = "(error " ++ e.haskell ++ ")";
}
aspect production stringToIntFunction
top::Expr ::= t::ToInt_kwd l::LParen_t e::Expr r::RParen_t
{
  top.haskell = "(read " ++ e.haskell ++ "::Int)";
}
aspect production stringToFloatFunction
top::Expr ::= t::ToFloat_kwd l::LParen_t e::Expr r::RParen_t
{
  top.haskell = "(read " ++ e.haskell ++ "::Float)";
}
aspect production numToStringFunction
top::Expr ::= t::ToString_kwd l::LParen_t e::Expr r::RParen_t
{
  top.haskell = "(show " ++ e.haskell ++ ")";
}

aspect production ftoiFunction
top::Expr ::= t::FTOI_kwd l::LParen_t e::Expr r::RParen_t
{
  top.haskell = "(floor " ++ e.haskell ++ ")";
}

aspect production itofFunction
top::Expr ::= t::ITOF_kwd l::LParen_t e::Expr r::RParen_t
{
  top.haskell = "(fromIntegral " ++ e.haskell ++ "::Float)";
}

aspect production isDigitFunction
top::Expr ::= t::IsDigit_kwd l::LParen_t e::Expr r::RParen_t
{
  top.haskell = "(" ++ e.haskell ++ " /= [] && foldl (\\l r -> isDigit r && l) True " ++ e.haskell ++ ")";
}

aspect production isAlphaFunction
top::Expr ::= t::IsAlpha_kwd l::LParen_t e::Expr r::RParen_t
{
  top.haskell = "(" ++ e.haskell ++ " /= [] && foldl (\\l r -> isAlpha r && l) True " ++ e.haskell ++ ")";
}

aspect production isSpaceFunction
top::Expr ::= t::IsSpace_kwd l::LParen_t e::Expr r::RParen_t
{
  top.haskell = "(" ++ e.haskell ++ " /= [] && foldl (\\l r -> isSpace r && l) True " ++ e.haskell ++ ")";
}

aspect production isLowerFunction
top::Expr ::= t::IsLower_kwd l::LParen_t e::Expr r::RParen_t
{
  top.haskell = "(" ++ e.haskell ++ " /= [] && foldl (\\l r -> isLower r && l) True " ++ e.haskell ++ ")";
}

aspect production isUpperFunction
top::Expr ::= t::IsUpper_kwd l::LParen_t e::Expr r::RParen_t
{
  top.haskell = "(" ++ e.haskell ++ " /= [] && foldl (\\l r -> isUpper r && l) True " ++ e.haskell ++ ")";
}

aspect production newFunction
top::Expr ::= n::New_kwd l::LParen_t e::Expr r::RParen_t
{
  top.haskell = "(new_NT_" ++ makeName(e.typerep.typeName) ++ " " ++ e.haskell ++ ")";
}
aspect production terminalFunction
top::Expr ::= term::Terminal_kwd l::LParen_t t::Type c::Comma_t e::Expr r::RParen_t
{
  top.haskell = "(TERMINAL { syns_TERMINAL = SYNS_TERMINAL { attr_TERMINAL__lexeme = " ++ e.haskell ++ ", " ++
							 "attr_TERMINAL__line = -1, " ++ 
							 "attr_TERMINAL__column = -1 }  })";
}
aspect production terminalFunction2
top::Expr ::= term::Terminal_kwd l::LParen_t t::Type c1::Comma_t e1::Expr c2::Comma_t e2::Expr c3::Comma_t e3::Expr r::RParen_t
{
  top.haskell = "(TERMINAL { syns_TERMINAL = SYNS_TERMINAL { attr_TERMINAL__lexeme = " ++ e1.haskell ++ ", " ++
							 "attr_TERMINAL__line = " ++ e2.haskell ++ ", " ++ 
							 "attr_TERMINAL__column = " ++ e3.haskell ++ " }  })";
}
