grammar silver:translation:c:core;
import silver:base;

synthesized attribute accessCount :: Integer;

synthesized attribute firstAccess :: String;
synthesized attribute secondAccess :: QName;

synthesized attribute firstAccessFull :: String;
synthesized attribute secondAccessFull :: String;


attribute accessCount occurs on LHSExpr;

attribute firstAccess occurs on LHSExpr;
attribute secondAccess occurs on LHSExpr;

attribute firstAccessFull occurs on LHSExpr;
attribute secondAccessFull occurs on LHSExpr;

aspect production fakeLHSExpr
top::LHSExpr ::= c1::QName c2::Decorated TypeRep
{
  top.accessCount = 1;

  top.firstAccess = "*";
  top.secondAccess = c1'';

  top.firstAccessFull = "";

  top.secondAccessFull = fName;
}

aspect production lhsExprOne
top::LHSExpr ::= id::Id_t
{
  top.accessCount = 1;

  top.firstAccess = id.lexeme;
  top.secondAccess = qNameId(terminal(Id_t, ""));

  top.firstAccessFull = fName;
  top.secondAccessFull = "" ;
}

aspect production lhsExprTwo
top::LHSExpr ::= id::Id_t d::Dot_t q::QName
{
  top.accessCount = 2;
  top.firstAccess = id.lexeme;
  top.secondAccess = q'';

  top.firstAccessFull = fName1;

  top.secondAccessFull = fName2;
}
