grammar silver:translation:c:core;
import silver:base;

nonterminal ProductionSpec;

synthesized attribute aspectName :: String occurs on ProductionSpec;

synthesized attribute productionName :: String occurs on ProductionSpec;
synthesized attribute productionNames :: [String] occurs on ProductionSpec;
synthesized attribute productionTypes :: [Decorated TypeRep] occurs on ProductionSpec;

synthesized attribute isAspectSpec :: Boolean occurs on ProductionSpec;
synthesized attribute isProductionSpec :: Boolean occurs on ProductionSpec;


synthesized attribute pSpecs :: [Decorated ProductionSpec];

function productionSpec
Decorated ProductionSpec ::= n::String ns :: [String] ts :: [Decorated TypeRep]{
 return decorate internal_productionSpec(n, ns, ts) with {};
}

abstract production internal_productionSpec
top::ProductionSpec ::= n::String ns :: [String] ts :: [Decorated TypeRep]{

  top.isProductionSpec = true;

  top.productionName = n;

  top.productionNames = ns;
  top.productionTypes = ts;

  forwards to defaultSpec();
}

function aspectSpec
Decorated ProductionSpec ::= an::String pn::String ns :: [String] ts :: [Decorated TypeRep]{
 return decorate internal_aspectSpec(an, pn, ns, ts) with {};
}

abstract production internal_aspectSpec
top::ProductionSpec ::= an::String pn::String ns :: [String] ts :: [Decorated TypeRep]{

  top.isAspectSpec = true;

  top.productionName = pn;
  top.aspectName = an;

  top.productionNames = ns;
  top.productionTypes = ts;

  forwards to defaultSpec();
}

abstract production defaultSpec
top::ProductionSpec ::=
{
  top.isAspectSpec = false;
  top.isProductionSpec = false;
}

