grammar silver:translation:c:core;
import silver:base;

--gets the defs for id.id situations.
function getDefsForName
[StmtRep] ::= cname::String l::[StmtRep]
{
  return if null(l) then []
         else if head(l).isAttributeDef
	      && head(l).lhsExpr.accessCount == 2
	      && head(l).lhsExpr.firstAccessFull == cname
              then cons(head(l), getDefsForName(cname, tail(l)))
              else getDefsForName(cname, tail(l));
}

--gets lname defs
function getLocalDefinition
[StmtRep] ::= lname::String l::[StmtRep]
{
  return if null(l) then []
         else if head(l).isAttributeDef
	      && head(l).lhsExpr.accessCount == 1
	      && head(l).lhsExpr.firstAccessFull == lname
              then cons(head(l), getLocalDefinition(lname, tail(l)))
              else getLocalDefinition(lname, tail(l));
}

function getLocalDeclarations
[StmtRep] ::= l::[StmtRep]
{
  return if null(l) then []
         else if head(l).isLocalDcl
              then cons(head(l), getLocalDeclarations(tail(l)))
              else getLocalDeclarations(tail(l));
}

function getForwardDeclarations
[StmtRep] ::= l::[StmtRep]
{
  return if null(l) then []
         else if head(l).isForwardsDcl
              then cons(head(l), getForwardDeclarations(tail(l)))
              else getForwardDeclarations(tail(l));
}

function getForwardingDeclarations
[StmtRep] ::= l::[StmtRep]
{
  return if null(l) then []
         else if head(l).isForwardingDcl
              then cons(head(l), getForwardingDeclarations(tail(l)))
              else getForwardingDeclarations(tail(l));
}
