grammar silver:translation:c:core;
import silver:base;

import silver:utils;

synthesized attribute translationType :: String;
attribute translationType occurs on TypeRep;

aspect production internal_integerTypeRep
top::TypeRep ::= 
{
  top.translationType = "Int";
}

aspect production internal_floatTypeRep
top::TypeRep ::= 
{
  top.translationType = "Float";
}

aspect production internal_stringTypeRep
top::TypeRep ::= 
{
  top.translationType = "String";

}

aspect production internal_booleanTypeRep
top::TypeRep ::= 
{
  top.translationType = "Bool";

}

aspect production internal_termTypeRep
top::TypeRep ::= n::String
{
  top.translationType = "TERMINAL";

}

aspect production internal_ntTypeRep
top::TypeRep ::= n::String
{
  top.translationType = "INHS_NT_" ++ makeName(n) ++ " -> NT_" ++ makeName(n);
}

aspect production internal_refTypeRep
top::TypeRep ::= t::Decorated TypeRep
{
  top.translationType = "NT_" ++ makeName(t.typeName);

}

aspect production internal_prodTypeRep
top::TypeRep ::= it::[Decorated TypeRep] ot::Decorated TypeRep
{
  top.translationType = makeTypeRepListC(it) ++ ot.translationType;
}

aspect production internal_topTypeRep
top::TypeRep ::= 
{
  top.translationType = "TOP";

}

function makeTypeRepListC
String ::= l::[Decorated TypeRep]
{
  return if null(l)
	 then ""
	 else "(" ++ head(l).translationType ++ ")" ++ " -> " ++ makeTypeRepListC(tail(l));
}


aspect production internal_ioTypeRep
top::TypeRep ::= 
{
  top.translationType = "IO Bool";
}

aspect production internal_defaultTypeRep
top::TypeRep ::= 
{
  top.translationType = "Int";
}