grammar silver:translation:haskell:happyalex;
import silver:base;
import silver:utils;


synthesized attribute alexSpec :: String;
synthesized attribute alexTokenSpec :: String ;

function makeAlexSpec
String ::= gn::String spec::Decorated RootSpec
{
  local attribute filtered :: FilterResult;
  filtered = filterSyntax(spec.hiddenSyntax, spec.terminalDcls, spec.ruleDcls);

  return 
	"{\n" ++
	"module Module_" ++ gn ++ "_Scanner where\n" ++
	"import Terminal\n" ++
	"}\n" ++ 
	"%wrapper \"posn\"\n" ++
	"tokens :-\n" ++
        makeAlexSpecString(tsMergeSort(filtered.terminalDcls)) ++ "\n\n" ++
	"{\n\n" ++
	"tok f p s = f p s\n" ++
	"count :: AlexPosn->String->AlexPosn\n" ++
	"count pos \"\" = pos\n" ++
	"count (AlexPn abs_n line_n column_n) ('\\n':cs) = count (AlexPn (abs_n+1) (line_n+1) 0 ) cs\n" ++
	"count (AlexPn abs_n line_n column_n) (c:cs) = count (AlexPn (abs_n+1) line_n (column_n+1) ) cs\n\n" ++
	"mkAlexTerm (AlexPn abs_begin line_begin column_begin)  (AlexPn abs_end line_end column_end) str\n" ++
	" = TERMINAL {syns_TERMINAL = SYNS_TERMINAL {attr_TERMINAL__lexeme = str, " ++ 
						    "attr_TERMINAL__line = line_begin," ++
						    "attr_TERMINAL__column = column_begin}}\n\n" ++
	"data Token =\n" ++
        makeAlexTokenSpec(filtered.terminalDcls) ++ "\n" ++
	"}\n";
}


function makeAlexSpecString
String ::= specs::[TerminalSpec]
{
  return if null(specs)
	 then ""
	 else "   " ++ substring(1, length(head(specs).terminalRegExpr) -1, head(specs).terminalRegExpr) ++ "\n" ++ 
	      (if head(specs).ignoreTerminal
	       then "    ; \n"
	       else "    { tok (\\p s -> (Token_" ++  makeName(head(specs).terminalName) ++ " (mkAlexTerm p (count p s) s))) } \n") ++
              makeAlexSpecString(tail(specs));
}

function makeAlexTokenSpec
String ::= specs::[TerminalSpec]
{
  return if null(specs)
	 then "    TT_Err  AlexPosn\n    deriving (Show)\n"
	 else "    Token_" ++ makeName(head(specs).terminalName) ++  " TERMINAL |\n" ++ makeAlexTokenSpec(tail(specs));
}