grammar silver:translation:haskelljava:concretesyntax;
import silver:base:core;
import silver:base:cs:default;
import silver:extension:collection only Contains_t;
import silver:analysis:typechecking:core;
import silver:utils;
import silver:translation:ag:haskell only haskell ;
import silver:extension:easyterminal only easyRegsDefs;


import silver:translation:haskelljava:core;

synthesized attribute hasCustomLayout :: Boolean;
synthesized attribute customLayout :: [String];

attribute hasCustomLayout occurs on GrammarInfo;
attribute customLayout occurs on GrammarInfo;

attribute env occurs on OptProductionModifiers,ProductionModifiers,ProductionModifier;

terminal Layout_kwd 'layout' lexer precedence = 5;

aspect production defaultGrammarInfo
top::GrammarInfo ::=
{
    top.hasCustomLayout = false;
    top.customLayout = [];
}

abstract production grammarInfoLayout
top::GrammarInfo ::= gLayout::[String]
{
    top.hasCustomLayout = true;
    top.customLayout = gLayout;
    forwards to defaultGrammarInfo();
}

aspect production mashGrammarInfos
top::GrammarInfo ::= gi1::GrammarInfo gi2::GrammarInfo
{
    top.hasCustomLayout = gi1.hasCustomLayout || gi2.hasCustomLayout;
    top.customLayout = gi1.customLayout +++ gi2.customLayout;
}

concrete production customLayoutDecl
top::AGDcl ::= g::Grammar_kwd l::Layout_kwd c::Contains_t lc::LCurly_t terms::TermPrecList rc::RCurly_t s::Semi_t
{
   top.pp = "grammar layout = { " ++ terms.pp ++ " }; ";
   top.location = "[line: " ++ toString(g.line) ++ ", column: " ++ toString(g.column) ++ "] ";
   top.defs = emptyDefs();
   top.globalDefs = emptyDefs();
   top.errors = terms.errors;
   top.typeErrors = terms.typeErrors;
   top.grammarInfo = grammarInfoLayout(terms.precTermList);
}

aspect production customLayoutDecl
top::AGDcl ::= g::Grammar_kwd l::Layout_kwd c::Contains_t lc::LCurly_t terms::TermPrecList rc::RCurly_t s::Semi_t
{
  top.hasStartSymbol = false;

  top.haskell = "";
  top.terminalDcls = [];			   
  top.parserUses = [];
  top.ruleDcls = [];
  top.ntDcls = [];
  top.parserAttrDcls = [];
  top.disambiguationGroupDcls = [];

  top.easyRegsDefs = [];
--  top.agnosis = [];
}


attribute hasCustomLayout occurs on OptProductionModifiers,ProductionModifier,ProductionModifiers,RHSSpec;
attribute customLayout occurs on OptProductionModifiers,ProductionModifier,ProductionModifiers,RHSSpec;

attribute errors occurs on OptProductionModifiers,ProductionModifiers,ProductionModifier;
attribute typeErrors occurs on OptProductionModifiers,ProductionModifiers,ProductionModifier;

--attribute hasGrammarNameSyn occurs on RuleSpec;
--synthesized attribute grammarNameSynNT :: String occurs on RuleSpec;

aspect production rhsSpec
top::RHSSpec ::= fn::String ns::[String] gName::Decorated QName m::Decorated OptProductionModifiers
{
   top.hasCustomLayout = m.hasCustomLayout;
   top.customLayout = m.customLayout;
}

aspect production optProductionModifiersNothing
top::OptProductionModifiers ::= 
{
  top.errors = "";
  top.typeErrors = "";
  top.hasCustomLayout = false;
  top.customLayout = [];
}

aspect production optProductionModifiersSomething
top::OptProductionModifiers ::= pm::ProductionModifiers
{
  top.errors = pm.errors;
  top.typeErrors = pm.typeErrors;
  top.hasCustomLayout = pm.hasCustomLayout;
  top.customLayout = pm.customLayout;
} 

aspect production productionModifiersCons
top::ProductionModifiers ::= h::ProductionModifier c::Comma_t t::ProductionModifiers
{
  top.errors = h.errors ++ t.errors;
  top.typeErrors = h.typeErrors ++ t.typeErrors;
  top.hasCustomLayout = h.hasCustomLayout || t.hasCustomLayout ;
  top.customLayout = h.customLayout +++ t.customLayout;
}
aspect production productionModifierSingle
top::ProductionModifiers ::= pm::ProductionModifier
{
  top.errors = pm.errors;
  top.typeErrors = pm.typeErrors;
  top.hasCustomLayout = pm.hasCustomLayout;
  top.customLayout = pm.customLayout;
}

aspect production productionModifierPrecedence
top::ProductionModifier ::= p::Precedence_kwd e::Equal_t i::Int_t
{
  top.errors = "";
  top.typeErrors = "";
  top.hasCustomLayout = false;
  top.customLayout = [];
}

concrete production productionModifierLayout
top::ProductionModifier ::= l::Layout_kwd e::Equal_t lc::LCurly_t terms::TermPrecList rc::RCurly_t
{
  top.errors = terms.errors;
  top.typeErrors = terms.typeErrors;
  top.hasParserPrec = false;
  top.parserPrec = 0;


  top.hasCustomLayout = true;
  top.customLayout = terms.precTermList;
}