grammar silver:translation:haskelljava:concretesyntax;
import silver:base:core;
import silver:base:cs:default;

attribute lexerClass occurs on TerminalSpec;
attribute staticPrec occurs on TerminalSpec;
attribute dynamicPrec occurs on TerminalSpec;
attribute usePrefix occurs on TerminalSpec;
attribute lexerClasses occurs on TerminalSpec ;
attribute submitsTo occurs on TerminalSpec ;
attribute dominates  occurs on TerminalSpec ;

synthesized attribute prefixGrammar :: String;

attribute grammarName occurs on TerminalModifiers;
attribute prefixGrammar occurs on TerminalSpec;

aspect production terminalSpec
top::TerminalSpec ::= fn::String ignored::Boolean reg::String
{
     top.lexerClass = "_main";
     top.staticPrec = 0;
     top.dynamicPrec = 0;
     top.usePrefix = false;
     top.prefixGrammar = "";
     top.lexerClasses = [] ;
     top.submitsTo = [] ;
     top.dominates = [] ;
     top.actionCode = actionCodeEmpty();
}

aspect production longTerminalSpec
top::TerminalSpec ::= fn::String ignored::Boolean tm::Decorated TerminalModifiers reg::String
{
    local attribute lexerClassL :: String;
    lexerClassL = if !tm.hasLexerClass
                  then "_main"
                  else tm.lexerClass;

    local attribute staticPrecL :: Integer;
    staticPrecL = if tm.hasStaticPrec
                then tm.staticPrec
                else if tm.hasLexerPrec
                     then tm.lexerPrec
                     else 0;

    local attribute dynamicPrecL :: Integer;
    dynamicPrecL = if tm.hasDynamicPrec
                   then tm.dynamicPrec
                   else if tm.hasLexerPrec
                        then tm.lexerPrec
                        else 0;

     top.lexerClass = lexerClassL;
     top.staticPrec = staticPrecL;
     top.dynamicPrec = dynamicPrecL;
     top.usePrefix = tm.usePrefix;
     top.prefixGrammar = if tm.usePrefix
                         then tm.grammarName.name
                         else "";

     top.lexerClasses = tm.lexerClasses ;
     top.submitsTo = tm.submitsTo ;
     top.dominates = tm.dominates ;
     top.actionCode = if tm.hasActionCode
                      then tm.actionCode
                      else actionCodeEmpty();
}

