grammar silver:translation:haskelljava:concretesyntax;
import silver:base:cs:default;
import silver:base:core;
import silver:analysis:typechecking:core;
import silver:utils;

--import silver:translation:haskelljava:core only haskell ;
import silver:translation:ag:haskell only haskell ;


import silver:translation:haskelljava:core;

-- Only for the aspect 'lexerClassDecl'.
--import silver:analysis:agnosis:core only agnosis;
-- Only for the aspect 'lexerClassDecl'.
import silver:extension:easyterminal only easyRegsDefs;

concrete production lexerClassDecl
top::AGDcl ::= l::Lexer_kwd cl::Class_kwd id::Id_t s::Semi_t
{
  top.pp = "lexer class " ++ id.lexeme ++ ";";
  top.location = "[line: " ++ toString(id.line) ++ ", column: " ++ toString(id.column) ++ "] ";

  production attribute fName :: String;
  fName = top.grammarName.name ++ ":" ++ id.lexeme;

  production attribute fName_dashes :: String ; 
  fName_dashes = makeName(fName);

  top.defs = addTypeDcl(fName, lexerClassTypeRep(fName_dashes), 
	     addFullNameDcl(id.lexeme, fName,
	     addOccursDcl("lexeme", fName,
 	     addOccursDcl("line", fName,
	     addOccursDcl("column", fName, emptyDefs())))));

  top.globalDefs = addTypeDcl(fName, lexerClassTypeRep(fName_dashes),
	           addOccursDcl("lexeme", fName,
 	           addOccursDcl("line", fName,
	           addOccursDcl("column", fName, emptyDefs()))));

  local attribute er1 :: String;
  er1 = if length(getFullNameDcl(id.lexeme, top.env)) > 1
       then top.location ++ "Error: Name '" ++ id.lexeme ++ "' is already bound.\n"
       else "";	

  local attribute er2 :: String;
  er2 = if length(getTypeDcl(fName, top.env)) > 1
       then top.location ++ "Error: Type '" ++ fName ++ "' is already bound.\n"
       else "";	

  top.errors = er1 ++ er2;
}


aspect production lexerClassDecl
top::AGDcl ::= l::Lexer_kwd cl::Class_kwd id::Id_t s::Semi_t
{
  top.hasStartSymbol = false;

  top.haskell = "";
  top.terminalDcls = [];			   
  top.parserUses = [];
  top.ruleDcls = [];
  top.ntDcls = [];

  top.easyRegsDefs = [];
  top.typeErrors = "";
--  top.agnosis = [];
}
