grammar silver:translation:haskelljava:concretesyntax;
import silver:base:cs:default;
import silver:base:core;

--import silver:translation:haskelljava:core;
import silver:translation:ag:haskell:core;

import silver:analysis:typechecking:core;
import silver:extension:easyterminal;

synthesized attribute isParserAttrDeclaration :: Boolean;
synthesized attribute parserAttrDeclaration :: ParserAttrSpec;

attribute isParserAttrDeclaration occurs on EnvItem;

-- This adds  parser_attr n  entries
function addParserAttrDcl
Decorated Defs ::= n::String e::Decorated Defs
{
  return consDefs(parserAttrEnvItem(n), e);
}

function parserAttrEnvItem
Decorated EnvItem ::= n::String
{
  return decorate internal_parserAttrEnvItem(n) with {};
}
abstract production internal_parserAttrEnvItem
top::EnvItem ::= n::String
{
  -- required to be defined.
  top.itemName = n;
  top.pp = "parser_attr " ++ n ;

  top.isParserAttrDeclaration = true;

  forwards to internal_defaultEnvItem();
}

synthesized attribute attrName :: String;
synthesized attribute attrType :: Type;

nonterminal ParserAttrSpec with {attrName,attrType,actionCode};

abstract production parserAttrSpec
top::ParserAttrSpec ::= aname::String atype::Type acode::ActionCode
{
   top.attrName = aname;
   top.attrType = atype'';
   top.actionCode = acode;

}

synthesized attribute parserAttrDcls :: [ParserAttrSpec];
attribute parserAttrDcls occurs on Root, RootSpec, AGDcls, AGDcl, ImportExportStmts;



aspect production attributeDclParser
top::AGDcl ::= pr::Parser_kwd at::Attribute_kwd a::Id_t ht::HasType_t te::Type act::Action_kwd acode::ActionCode_c s::Semi_t
{
   top.parserAttrDcls = [parserAttrSpec(fName,te'',acode.actionCode)];




--  top.agnosis = [];
  top.typeErrors = ""; -- Finalize
  top.easyRegsDefs = [];
  top.hasStartSymbol = false;
  top.terminalDcls = [];
  top.ruleDcls = [];
  top.parserUses = [];
  top.ntDcls = [];
  top.haskell = "";
}

aspect production lexerClassDecl
top::AGDcl ::= l::Lexer_kwd cl::Class_kwd id::Id_t s::Semi_t
{
  top.parserAttrDcls = [];
}

aspect production disambiguationGroupDcl
top::AGDcl ::= 'disambiguation' 'group' id::Id_t w::With_kwd lc::LCurly_t terms::TermPrecList  rc::RCurly_t act::Action_kwd acode::ActionCode_c s::Semi_t
{
  top.parserAttrDcls = [];
}



aspect production defaultNonterminalDcl
top::AGDcl ::= id::Id_t
{
  top.parserAttrDcls = [];			   
}

aspect production defaultClosedNonterminalDcl
top::AGDcl ::= id::Id_t
{
  top.parserAttrDcls = [];			   
}

aspect production closeNonterminalDcl
top::AGDcl ::= c::Close_kwd q::QName  s::Semi_t
{
  top.parserAttrDcls = [ ];			   
}

aspect production emptyRootSpec
top::RootSpec ::= 
{
  top.parserAttrDcls = [];
}

aspect production consRootSpec
top::RootSpec ::= c1::Decorated Root c2::Decorated RootSpec
{
  top.parserAttrDcls = c1.parserAttrDcls +++ c2.parserAttrDcls;
}

aspect production appendRootSpec
top::RootSpec ::= c1::Decorated RootSpec c2::Decorated RootSpec
{
  top.parserAttrDcls = c1.parserAttrDcls +++ c2.parserAttrDcls;
}




aspect production attributeDclInh
top::AGDcl ::= i::Inherited_kwd  at::Attribute_kwd a::Id_t ht::HasType_t te::Type s::Semi_t
{
  top.parserAttrDcls = [];
}

aspect production attributeDclSyn
top::AGDcl ::= sn::Synthesized_kwd  at::Attribute_kwd a::Id_t ht::HasType_t te::Type  s::Semi_t
{
  top.parserAttrDcls = [];
}

aspect production importStmtsNone
top::ImportExportStmts ::=
{
  top.parserAttrDcls = [];
}

aspect production importStmtsOne 
top::ImportExportStmts ::= im::ImportStmt
{
  top.parserAttrDcls = [];
}

aspect production exportStmtsOne 
top::ImportExportStmts ::= ex::ExportStmt
{
  top.parserAttrDcls = [];
}

aspect production importStmtsCons
top::ImportExportStmts ::= h::ImportStmt t::ImportExportStmts
{
  top.parserAttrDcls = t.parserAttrDcls;
}

aspect production exportStmtsCons
top::ImportExportStmts ::= h::ExportStmt t::ImportExportStmts
{
  top.parserAttrDcls = t.parserAttrDcls;
}

aspect production appendImportsExports
top::ImportExportStmts ::= fst::ImportExportStmts snd::ImportExportStmts
{
  top.parserAttrDcls = fst.parserAttrDcls +++ snd.parserAttrDcls;
}

aspect production attributionDcl
top::AGDcl ::= at::Attribute_kwd a::QName oc::Occurs_kwd o::On_kwd nt::QName s::Semi_t
{
  top.parserAttrDcls = [];
}

aspect production productionDcl
 top::AGDcl ::=
   a::Abstract_kwd p::Production_kwd id::Id_t ns::ProductionSignature
   body::ProductionBody
{
  top.parserAttrDcls = [];
}

aspect production aspectAGDcl
 top::AGDcl ::=
   a::Aspect_kwd p::Production_kwd id::QName ns::AspectSignature
   body::ProductionBody
{
  top.parserAttrDcls = [];
}

aspect production root
top::Root ::= gdcl::GrammarDcl ims::ImportExportStmts ags::AGDcls
{
  top.parserAttrDcls = ags.parserAttrDcls +++ ims.parserAttrDcls;
}

aspect production agDclsOne
top::AGDcls ::= ag::AGDcl
{
  top.parserAttrDcls = ag.parserAttrDcls ;
}

aspect production agDclsCons
top::AGDcls ::= h::AGDcl t::AGDcls
{
  top.parserAttrDcls = h.parserAttrDcls +++ t.parserAttrDcls;
}

aspect production agDclSeq
top::AGDcl ::= ag1::AGDcl ag2::AGDcl
{
  top.parserAttrDcls = ag1.parserAttrDcls +++ ag2.parserAttrDcls;
}

aspect production agDclNone
top::AGDcl ::=
{
  top.parserAttrDcls = [];
}

attribute parserAttrDcls occurs on SyntaxStmt;

aspect production syntaxStmtsOne 
top::ImportExportStmts ::= syn::SyntaxStmt
{
  top.parserAttrDcls = syn.parserAttrDcls;
}

aspect production syntaxStmtsCons
top::ImportExportStmts ::= h::SyntaxStmt t::ImportExportStmts
{
  top.parserAttrDcls = h.parserAttrDcls +++ t.parserAttrDcls;
}

aspect production syntaxAll
top::SyntaxStmt ::= s::Syntax_kwd pkg::QName se::Semi_t
{
  top.parserAttrDcls = spec.parserAttrDcls;
}

aspect production syntaxHiding
top::SyntaxStmt ::= s::Syntax_kwd  pkg::QName h::Hiding_kwd ns::NameList se::Semi_t
{
  top.parserAttrDcls = spec.parserAttrDcls;
}

aspect production terminalDcl
top::AGDcl ::= t::Terminal_kwd id::Id_t r::RegExpr s::Semi_t
{
  top.parserAttrDcls = [];
}
