grammar silver:translation:haskelljava:core;
import silver:translation:haskelljava:command;
import silver:base hiding grammarName;
import silver:utils:command;
import silver:utils;
import silver:translation:ag:haskell ;

import core;


aspect production run
top::RunUnit ::= iIn::IO args::String p::Production(Root ::= String)
{
  postOps <- if a.noHaskellGeneration  || a.onlyCSGen then [] else [genHaskell(a'', grammars)]; 
}


aspect production genHaskellHelp
top::Unit ::= a::Command specs::[GrammarSpec]
{
  local attribute i0 :: IO;
  i0 = writeFile(a.generatedPath ++ "Terminal.hs", term, top.ioIn);

  local attribute i1 :: IO;
  i1 = writeFile(a.generatedPath ++ "Module_" ++ hn ++ ".hs-boot", mod_boot, i0);

  local attribute i2 :: IO;
  i2 = writeFile(a.generatedPath ++ "Module_" ++ hn ++ ".hs", header, i1);

  local attribute i3 :: IO;
  i3 = writeAll(i2, a, specs, pUses);

  local attribute i4 :: IO;
  i4 = writeMainHS(i3, a);
    
  production attribute c :: IOString;
  c = cwd(i4);

  local attribute javac :: IOString;
  javac = buildJavaCString(specs,a'',c.io,pUses);

  local attribute ghc_compile_str :: String;
  ghc_compile_str = 
		    "echo \"ghc -c Terminal.hs\"\n" ++ 
		    "ghc  -c Terminal.hs\n" ++ 
		    "echo \"ghc -c Module_" ++ hn ++ ".hs-boot\"\n" ++
		    "ghc  -c Module_" ++ hn ++ ".hs-boot\n" ++
                     buildGHCBootString(specs, pUses) ++ 
		    "echo \"ghc -c Module_" ++ hn ++ ".hs\"\n" ++
		    "ghc  -c Module_" ++ hn ++ ".hs\n" ++
                     javac.sValue ++ 
                     buildParserString(specs, pUses) ++ 
		    "echo \"ghc -c Main.hs\"\n" ++
		    "ghc  -c Main.hs\n" ++
		    "echo \"ghc -o " ++ c.sValue ++ "/" ++ a.outName ++ " Main.o Terminal.o Module_" ++ hn ++ ".o " ++ buildLinkString(specs, pUses) ++ "\"\n" ++
		    "ghc -o " ++ c.sValue ++ "/" ++ a.outName ++ " Main.o Terminal.o Module_" ++ hn ++ ".o " ++ buildLinkString(specs, pUses) ++ "\n";



  local attribute i5 :: IO;
  i5 = writeFile(a.generatedPath ++ "ghc-compile", ghc_compile_str, javac.io);

  top.io = if a.noGHCCompile 
           then -- i5 
                system("pushd " ++ a.generatedPath ++ ">> /dev/null; chmod +x ./ghc-compile;                popd >> /dev/null", i5).io
           else system("pushd " ++ a.generatedPath ++ ">> /dev/null; chmod +x ./ghc-compile; ./ghc-compile; popd >> /dev/null", i5).io;

  top.code = 0;
  top.order = 3;

}

function buildLinkString
String ::= cl::[GrammarSpec] s::[String]
{
  local attribute n :: String;
  n = "Module_" ++ makeName(head(cl).name);

  local attribute has_start :: Boolean;
  has_start = head(cl).rootSpec.hasStartSymbol && containsString(head(cl).name ++ ":parse", s);

  return if null(cl) 
	 then ""
	 else if has_start
	      then n ++ "_Parser.o " ++ buildLinkString(tail(cl), s)
	      else buildLinkString(tail(cl), s);
}





--
--function buildCCString
--IOString ::= cl::[GrammarSpec] a::Command i::IO s::[String]
--{
--  local attribute envArg :: IOString;
--  envArg = envVar("GRAMMAR_PATH", i);
--
--  local attribute sPath :: String;
--  sPath = a.searchPath ++ ":" ++ envArg.sValue;
--
--  local attribute spath :: [String];
--  spath = getSearchPath(sPath);
--
--  --the grammar path ':' replaced by '/'
--  local attribute gpath :: String;
--  gpath = getGrammarPath(head(cl).name) ++ "/";
--
--  local attribute gloc :: MaybeIOStr;
--  gloc = findGrammarLocation(envArg.io, gpath, spath);
--  
--  local attribute i2 :: IO;
--  i2 = system("mkdir -p " ++ gloc.sValue ++ "/.parsers/`arch`", gloc.io).io;
--
--  local attribute n :: String;
--  n = "Module_" ++ makeName(head(cl).name);
--
--  local attribute c :: IOString;
--  c = cwd(i2);
--
--  local attribute out :: String;
--  out = (if substring(0, 1, gloc.sValue) == "/" then "" else c.sValue ++ "/") ++ gloc.sValue ++ "/.parsers/`arch`/" ++ makeName(head(cl).name) ++ "_parser";
--
--  local attribute recurse1 :: IOString;
--  recurse1 = buildCCString(tail(cl), a'', c.io, s);
--
--  local attribute recurse2 :: IOString;
--  recurse2 = buildCCString(tail(cl), a'', gloc.io, s);
--
--  return if null(cl)
--	 then ioString(i, "") 
--	 else if head(cl).rootSpec.hasStartSymbol && containsString(head(cl).name ++ ":parse", s)
--	      then if gloc.found
--		   then ioString(recurse1.io, "echo \"gcc -o " ++ out ++ " " ++ n ++ "_Parser.c " ++ n ++ "_Scanner.c\"\n" ++ 
-- 		   	                      "gcc -o " ++ out ++ " " ++ n ++ "_Parser.c " ++ n ++ "_Scanner.c\n" ++ 
--				  	      recurse1.sValue)
--		   else error("You Should Not Get Here.")
--	      else recurse2'';
--}
--
