grammar silver:translation:haskelljava:core;
import silver:translation:haskelljava:command;
import silver:base hiding grammarName;
import silver:utils:command;
import silver:utils;

import core;

function buildJavaCString
IOString ::= cl::[GrammarSpec] a::Command i::IO s::[String]
{
  local attribute envArg :: IOString;
  envArg = envVar("GRAMMAR_PATH", i);

  local attribute sPath :: String;
  sPath = a.searchPath ++ ":" ++ envArg.sValue;

  local attribute spath :: [String];
  spath = getSearchPath(sPath);

  --the grammar path ':' replaced by '/'
  local attribute gpath :: String;
  gpath = getGrammarPath(head(cl).name) ++ "/";

  local attribute gloc :: MaybeIOStr;
  gloc = findGrammarLocation(envArg.io, gpath, spath);
  
  local attribute i2 :: IO;
  i2 = system("mkdir -p " ++ gloc.sValue ++ "/.parsers/`arch`", gloc.io).io;

  local attribute n :: String;
  n = "Module_" ++ makeName(head(cl).name);

  local attribute c :: IOString;
  c = cwd(i2);

  local attribute out :: String;
  out = (if substring(0, 1, gloc.sValue) == "/" then "" else c.sValue ++ "/") ++ gloc.sValue ++ "/.parsers/`arch`"; -- ++ "/" ++ makeName(head(cl).name) ++ "_parser";

  local attribute recurse1 :: IOString;
  recurse1 = buildJavaCString(tail(cl), a'', c.io, s);

  local attribute recurse2 :: IOString;
  recurse2 = buildJavaCString(tail(cl), a'', gloc.io, s);

  return if null(cl)
	 then ioString(i, "") 
	 else if head(cl).rootSpec.hasStartSymbol && containsString(head(cl).name ++ ":parse", s)
	      then if gloc.found
		   then ioString(buildJavaShellScript(a,recurse1.io,head(cl),out), "echo \"javac -classpath " ++ a.javaClassPath ++ ":. -d " ++ out ++ " " ++ n ++ "_Grammar.java\"\n" ++ 
 		   	                      "javac -classpath " ++ a.javaClassPath ++ ":. -d " ++ out ++ " " ++ n ++ "_Grammar.java\n" ++
                                              "echo \"chmod ug+x " ++ makeName(head(cl).name) ++ "_parser\"\n" ++
                                              "chmod ug+x " ++ makeName(head(cl).name) ++ "_parser\n" ++
--                                              "echo \"mv -v " ++ makeName(head(cl).name) ++ "_parser " ++ out ++ "\"\n" ++
                                              "mv -v " ++ makeName(head(cl).name) ++ "_parser " ++ out ++ "\n" ++
				  	      recurse1.sValue)
		   else error("You Should Not Get Here.")
	      else recurse2'';
}

function buildJavaShellScript
IO ::= a::Decorated Command i::IO spec::GrammarSpec out::String
{
  local attribute n :: String;
  n = makeName(spec.name);

  return if spec.rootSpec.hasStartSymbol
	      then writeFile(a.generatedPath ++ n ++ "_parser","#!/bin/sh\n\njava -classpath " ++ a.javaClassPath ++ ":" ++ out ++ " " ++ "Module_" ++ n ++ "_Grammar\n",i)
	      else i;
}
