grammar silver:utils;
import core;
export silver:utils;

function containsString
Boolean ::= s::String sl::[String]
{
  return if null(sl)
 	 then false
	 else if (head(sl) == s)
	      then true
              else containsString(s, tail(sl));
}

function convert
[String] ::= sl::StringList
{
  return if sl.empty 
	 then []
	 else cons(sl.sh, convert(sl.st));
}

function splitName
[String] ::= str::String
{
  local attribute i :: Integer;
  i = indexof(":", str);

  return if i == -1
         then [str]
         else [substring(0, i, str)] +++ splitName(substring(i+1, length(str), str));
}

function makeName
String ::= str::String
{
  local attribute i :: Integer;
  i = indexof( ":", str);

  return if i == -1
         then str
         else substring(0, i, str) ++ "_" ++ makeName(substring(i+1, length(str), str));
}

function makeDirectory
String ::= str::String
{
  local attribute i :: Integer;
  i = indexof( ":", str);

  return if i == -1
         then str
         else substring(0, i, str) ++ "/" ++ makeDirectory(substring(i+1, length(str), str));
}

